#---------------------------------------------------
#  chkconsist
# 
#  gawk -f chkconsist.awk summary.port
#
#  summary.port is produced by "collectports"
#  where summary.port  is the file contains all port name index 
#  the format of summary.port
#  TOTAL 2
#  NET a1
#  .......
#  END eno
#  NET a2
#  ......
#  END eno
#
#--------------------------------------------------------
BEGIN {
  tbno = 0 ;
  netno = 1 ;
  no = 0 ;  
}
/TOTAL/ {
  nets = $2 ; 
  next ;
}
/NET/ { 
  netname = $2 ;
  netid[netno] = netname ;
  currentnetno = netno ;
  netno++ ;
  bno = 0 ;
  next ;
}
/END/ {
  next ;
}    
/./ {

  if (gettaskfromXXYY($3) == netname) {
#   this port is a server port 
#   we save it in tb_array to be searched
    tb_portname[tbno] = $3 ;
    tb_offset[tbno] = $2 ;
    tb_netname[tbno] = $1 ;
    tb_calledno[tbno] = 0 ;
    tbno ++ ;
  } else {
#   this port is a client port
#   it will connect to other port later
    from[no] = netname ;
    to[no] = $1 ;
    from_offset[no] = $2 ;
    portname[no] = $3 ;
    no ++ ;
  }
# save the content of net 
  behavid[bno] = $2 ;
  behavname[bno] = $3 ;
  bno ++ ;
}
END {
  errno = 1 ;
  for (i=0;i<no; i++) {
# first check if destination exists
    if (getnetid(to[i]) == -1 ) {
      print "ERROR [" errno "]: " from[i] "  port:" portname[i] ;
      print "      - server side does not exist " ;
      errno ++ ;
    } 
    p = searchtable(portname[i]);
    if (p == -1) {
      print "ERROR [" errno "]:"  from[i] " port:"  portname[i] ;
      print " - portname does not exist in any server task " ;
      errno++ ;
    } else 
      tb_calledno[p]++ ;
  }
  for (i=0; i< tbno; i++) {
    if (tb_calledno[i] == 0) {
      print "WARNING [" errno "]:"  tb_netname[i] "  port:" tb_portname[i];
      print "        - the portname has not been called by any clients " ;
      errno ++ ;
    }
  }
}


function getnetid(netname)  {
     for (n=1;n<netno; n++) {
        if (netid[n] == netname) 
           return n ;
     }
     return -1 ;
}     
function searchtable(name) {
  for (k=0;k<tbno; k++) {
    if (name == tb_portname[k])
      return k ;
  }
  return -1 ;
}
function gettaskfromXXYY(name) {
  return substr(name,1,index(name,"XX")-1);
}

     
