#
#  dorename.awk
#  
#        gawk -f dorename.awk rename.list foo.fc2 
#
#  this awk script read an rename.list file in 1st pass
#  in second pass  it read an fc2 file and replace the portname
#  according to rename.list
#
BEGIN { 
  rename = 0 ; 
  pairno = 0 ;
  structcoming = 0 ;
}

/RENAME/ { 
  rename = 1 ; 
  next ; 
}
/nets/ { 
  rename = 0 ;
  if (rename == 0)
    print ;
  next ;
}
 
/S1/ {
# this format happens wen fc2 file is generated from fc2explicit
  if (rename == 0)
    structcoming = 1 ;
}
/"[a-zA-Z0-9_]+"/ {
  
  if (rename == 0) {
    portname = substr($0, match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
    pureportname = substr(portname,2,RLENGTH-2);
    if (structcoming == 1) {
      structcoming = 0 ;
      netname = pureportname ;
    } else {
      k= searchrename(pureportname);
      if (k != -1) {
# the pureportname is in rename.list
# this port should be renamed
	newname = "\"" new[k] "\"" ;
	gsub(/"[a-zA-Z0-9_]+"/,newname);
      }
    }
    print ;
    next ;
  }
}
/./ { 
  if (rename == 1) {
    old[pairno] = $1 ;
    new[pairno] = $2 ;
    pairno ++ ;
  } else 
    print ;
}

function searchrename(name) {
  for (i=0;i< pairno; i++) {
    if (old[i] == name )
      return i ;
  }
  return -1 ;
}

  
  
