#-------------------------------------------------------
# getrename.awk
# 
# This program is called by composefc2. You should not
# call it directly.
# 
#     gawk -f getrename.awk task.list newsubsys.fc2 .....
#
#  This program process newsubsys.fc2 (usually generated by fc2explict
#  to check its
#-------------------------------------------------------
BEGIN {
  pass = 0 ;
  structcoming = 0 ;
  tasklist = 0 ;
  netno = 0 ;
}
/TASKLIST/ { tasklist = 1 ; }
/nets/ { 
  if ($2 != 1) {
#  this is a net file
    print "ERROR: file " FILENAME " is a fc2 net file! " ;
    print "       please delete and run your program again " ;
    exit 1;
  }
 
  tasklist = 0 ;
  print "RENAME FILE PRODUCED BY rename.awk" ;
}
  
/struct/ {
  if (tasklist == 0) {
    rawname = substr($0, match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
    netname = substr(rawname,2,RLENGTH-2);
  }
}
/S1/ {
# this format happens wen fc2 file is generated from fc2explicit
  structcoming = 1 ;
  exit 1 ;  
}
/:[0-9]+/ {
  if (tasklist == 0) {
    portname = substr($0, match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
    pureportname = substr(portname,2,RLENGTH-2);
    if (structcoming == 1) {
      structcoming = 0 ;
      netname = pureportname ;
    } else {
      task = gettaskfromXXYY(pureportname);
      if (searchsubtask(task) == 1) {
# the task name is in task.list
# this port should be renamed
	print pureportname " " netname gettail(pureportname) ;
      }
    }
    
  }
}
/./ { 
  if (tasklist == 1) {
    subtaskname[netno] = $0 ;
    netno ++ ;
  }
}

function searchsubtask(name) {
  for (i=0;i< netno; i++) {
    if (subtaskname[i] == name) 
      return 1 ;
  }
  return 0 ;
}
   
function gettaskfromXXYY(name) {
  return substr(name,1,index(name,"XX")-1);
}
function gettail(name) {
  return substr(name,index(name,"XX"));
}
